#include "../include/ce30_sdk.h"
#include <unistd.h>
#include <fstream>
//#define DEBUG

bool gRun = true;

void sig_stop(int value)
{
    gRun = false;
    return;
}

int main()
{
    gRun = true;
    signal(SIGINT, sig_stop);

    printf("Init device\n");
    int sd = 0;
    if(!benewake::initDevice(sd))
        return -1;
    #ifdef DEBUG
    std::ofstream map1("map_x.txt"), map2("map_y.txt");
    for(int i = 0; i < HEIGHT; i++)
    {
        for(int j = 0; j < WIDTH; j++)
        {
            map1 << benewake::mapX[i * WIDTH + j] << " ";
            map2 << benewake::mapY[i * WIDTH + j] << " ";
        }
        map1 << std::endl;
        map2 << std::endl;
    }
    map1.close();
    map2.close();
    #endif // DEBUG


    int h = HEIGHT, w = WIDTH;
    unsigned short data[h * w] , tmp = 0;
    int i = 0;

    std::ofstream outFile("data.txt");
    printf("Start processing ...\n");
    while(gRun)
    {
        if(!benewake::getDistanceData(sd, data, h, w))
        {
            outFile.close();
            benewake::closeDevice(sd);
            return -1;
        }
        else
        {
            i++;
            printf("Received %d frames.\n", i);
        }

        // output data to file
        outFile << "Distance:\n";
        for(int i = 0; i < h; i++)
        {
            for(int j = 0; j < w; j++)
            {
                outFile << data[i * w + j] << " ";
            }
            outFile << std::endl;
        }
    }
    outFile.close();
    benewake::closeDevice(sd);
    close(sd);

    return 0;
}
